package ru.amse.timkina.archiver.filetree;
import java.util.*;

public class File implements IFile {	
	
	private String myName;
	private String myFullPath;
	private String myComment = "";
	private Calendar myDate;
	public long mySize;
	private String myShortName;
	private IDirectory myParent;
		
	public File(long size) {
		myParent = null;
		mySize = size;
	}
	
	public IDirectory getParent() {
		return myParent;
	}
	
	public void setParent(IDirectory directory) {
		myParent = directory;
	}
	
	public void setModificationTime(Calendar date) {
		myDate = date;
	}
	
	public void setComment(String comment) {
		myComment = comment;
	}	
	
	public void setName(String name) {
		myName = name;
		int last;
		if(myName.lastIndexOf('/',myName.length() - 2)== -1) {
			last = 0;
		} else {
			last = myName.lastIndexOf('/', myName.length() - 2) + 1;
		}
		if (isDirectory() && (myName.endsWith("/"))){
			myShortName = myName.substring(last, myName.length() - 1);
		} else {
			myShortName = myName.substring(last, myName.length());
		}
	}
	
	public void setFullPath(String path) {
		myFullPath = path;
	}
	
	public Calendar getModificationTime() {
		return myDate;
	}
	
	public long getSize() {
		return mySize;
	}
	
	public String getName() {
		return myName;
	}
	
	public String getShortName() {
		return myShortName;
	}
	
	public String getFullPath() {
		return myFullPath;
	}
	
	public String getComment() {
		return myComment;
	}
	
	public boolean isDirectory() {
		return false;
	}
	
	public List<IDirectory> getDirectories() {
		return null;
	}
	public List<IFile> getFiles() {
		return null;
	}

	public String toString() {
		return myShortName;
	}
	
	

}
