package ru.amse.timkina.archiver.ui;

import javax.swing.JTree;
import javax.swing.tree.TreePath;

import ru.amse.timkina.archiver.filetree.IDirectory;
import ru.amse.timkina.archiver.ui.tree.FileTreeModel;

public class DirectoryChangeListener {
	private final JTree myTree;
	
	public DirectoryChangeListener(JTree tree) {
		myTree = tree;
	}
	
	public void directoryChanged(IDirectory directory, boolean isParent,
			   IDirectory oldDirectory) {		
		TreePath path = ((FileTreeModel) myTree.getModel()).getPath(directory);
		myTree.setSelectionPath(path);
		myTree.expandPath(path);
		if (isParent) {
			TreePath pathOld = ((FileTreeModel) myTree.getModel()).getPath(oldDirectory);
			myTree.setSelectionPath(pathOld);
			myTree.collapsePath(pathOld);
		}
	}
}
