package ru.amse.timkina.archiver.ui;

import javax.swing.JTree;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeWillExpandListener;

import ru.amse.timkina.archiver.filetree.IDirectory;
import ru.amse.timkina.archiver.filetree.IFile;
import ru.amse.timkina.archiver.ui.table.MainTableModel;
import ru.amse.timkina.archiver.ui.tree.FileTreeModel;

public class FileTreeWillExpandListener implements TreeWillExpandListener  {
	private final JTree myTree;
	private final MainTableModel myModel;
	
	
	public FileTreeWillExpandListener(JTree tree, MainTableModel model) {
		myTree = tree;
		myModel = model;
	}
	
	public void treeWillCollapse(TreeExpansionEvent e) {
		 IFile node = 
				((IFile) myTree.getLastSelectedPathComponent()).getParent();
		 synchronizeTableWithTree(node);
     }
	 
    public void treeWillExpand(TreeExpansionEvent e) {
		 IFile node = 
				(IFile)myTree.getLastSelectedPathComponent();
		 synchronizeTableWithTree(node);
	 }

	private void synchronizeTableWithTree(IFile node) {		
	    if (node != null) {
	        if (node != ((FileTreeModel)myTree.getModel()).getRoot()){        		
	        	if (node.isDirectory()) {
	        		IDirectory nodeAsDirectory = (IDirectory) node;
	        		if (!nodeAsDirectory.hasUp()) {
	        			nodeAsDirectory.addUp();
	        		}
	        		myModel.setDirectory(nodeAsDirectory);
	        	}
	        } else {
	        	myModel.setDirectory((IDirectory) node);
	        }
	    }
	}
}
