package ru.amse.timkina.archiver.ui.menu;


import java.awt.event.ActionEvent;
import java.io.IOException;
import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import java.io.File;
import java.net.URL;

import ru.amse.timkina.archiver.filetree.IDirectory;
import ru.amse.timkina.archiver.ui.ArchiverFrame;
import ru.amse.timkina.archiver.zipprocessor.ZipLoader;

public class OpenAction extends AbstractAction {
	
	private File myCurrentDir;
	private final ArchiverFrame myFrame;
	
	public OpenAction(ArchiverFrame frame) {
		putValue(NAME, "Open");
		putValue(SHORT_DESCRIPTION, "Open file");
		myFrame = frame;
		URL openURL = myFrame.getClass().getResource("Open.jpg");		
		ImageIcon open = new ImageIcon(openURL);		
		putValue(SMALL_ICON, open);
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(myCurrentDir);
		fc.setDialogTitle("File to open");
		int res = fc.showOpenDialog(fc);
		if (res == JFileChooser.APPROVE_OPTION) {
			myCurrentDir = fc.getCurrentDirectory();
			try {						
				IDirectory directory = new ZipLoader().loadFile(fc.getSelectedFile().getAbsolutePath());
				directory.addUp();
				myFrame.loadArchive(directory);
			} catch(IOException ex) {
				JOptionPane.showMessageDialog(myFrame, ex.getMessage());
			}		
		}	
	}
}
